checkout/urls.py
from django.urls import path 
from . views import checkout, payment, charge, oderView



app_name = "checkout"

urlpatterns = [
	path('checkout/', checkout, name="index"),
	path('payment/', payment, name="payment"),
	path('charge/', charge, name="charge"),
	path('my-orders/', oderView, name="oderView"),
	
]

ecommerce/urls.py
from django.contrib import admin
from django.urls import path,include

from django.conf import settings
from django.conf.urls.static import static
#for static files
#from django.contrib.staticfiles.urls import staticfiles_urlpatterns
urlpatterns = [
    path('', include('products.urls', namespace='mainapp')),
    path('', include('checkout.urls', namespace='checkout')),
    path('admin/', admin.site.urls),
    path('accounts/', include('allauth.urls')),
    path('payment/', include('payment.urls')),
]+ static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

#if settings.DEBUG:
#    import debug_toolbar
#    urlpatterns += [path('__debug__/', include(debug_toolbar.urls))]
#    urlpatterns += static(settings.MEDIA_URL,
#                          document_root=settings.MEDIA_ROOT)
#    urlpatterns += static(settings.STATIC_URL,
#                          document_root=settings.STATIC_ROOT)


#urlpatterns += staticfiles_urlpatterns()

payment/urls.py
"""
Author: Apu Kumar Chakroborti
"""
from django.urls import path
from . import views
from payment.views import create

urlpatterns = [
    path('paymentbkash/', create, name='create'),
]

products/urls.py
from django.urls import path
from . views import Home,ProductDetail

#for cart app
from cart.views import add_to_cart, remove_from_cart, CartView, decreaseCart

app_name= 'mainapp'

urlpatterns = [
    path('', Home.as_view(), name='home'),
    #for cart app
    path('cart/<slug>', add_to_cart, name='cart'),
    path('remove/<slug>', remove_from_cart, name='remove-cart'),

    path('product/<slug>/', ProductDetail.as_view(), name='product'),
    path('cart/', CartView, name='cart-home'),
    path('decrease-cart/<slug>', decreaseCart, name='decrease-cart'),
]

products/models.py
from django.db import models
from django.urls import reverse


# Create your models here.

class Category(models.Model):
    title = models.CharField(max_length=300)
    primaryCategory = models.BooleanField(default=False)

    def __str__(self):
        return self.title

#Product Model
class  Product(models.Model):
    mainimage = models.ImageField(upload_to='products/', blank=True)
    name = models.CharField(max_length=300)
    slug = models.SlugField()
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    preview_text = models.TextField(max_length=200, verbose_name='Preview Text')
    detail_text = models.TextField(max_length=1000, verbose_name='Detail Text')
    price = models.FloatField()
    

    def __str__(self):
        return self.name


    def get_absolute_url(self):
        return reverse("mainapp:product", kwargs={
            'slug': self.slug
        })

products/views.py
from django.shortcuts import render
# Create your views here.
from django.views.generic import ListView, DetailView
from products.models import Product
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator

from django.contrib.auth.mixins import LoginRequiredMixin


class Home(ListView):
    model = Product
    template_name = 'products/home.html'

class ProductDetail(LoginRequiredMixin, DetailView):
	model = Product

products/templates/products/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.10.2/css/all.css" rel="stylesheet">
  <link rel="stylesheet" href="{% static 'css/main.css' %}">
  <title>Djago Ecommer | manascode.com</title>
  <style>
  	.card{
  		    height: 350px;
  	}
  	.card-product:after {
    content: "";
    display: table;
    clear: both;
    visibility: hidden; }
  .card-product .price-new, .card-product .price {
    margin-right: 5px; }
  .card-product .price-old {
    color: #999; }
  .card-product .img-wrap {
    border-radius: 3px 3px 0 0;
    overflow: hidden;
    position: relative;
    height: 220px;
    text-align: center; }
    .card-product .img-wrap img {
      max-height: 100%;
      max-width: 100%;
      object-fit: cover; }
      
      .card-product .info-wrap {
    overflow: hidden;
    padding: 15px;
    border-top: 1px solid #eee; }
  .card-product .action-wrap {
    padding-top: 4px;
    margin-top: 4px; }
  .card-product .bottom-wrap {
    padding: 15px;
    border-top: 1px solid #eee; }
  .card-product .title {
    margin-top: 0; }
  </style>
</head>
<body>
{% include 'products/navbar.html' %}

    {% if messages %}
    <div class="messages container mt-2">
        {% for message in messages %}
        <div {% if message.tags %} class="alert alert-{{ message.tags }}{% endif %}" role="alert">
          {{ message }}
          <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
      </button>
        </div>
        {% endfor %}
    </div>
  {% endif %}
{% block content %}
{% endblock %}
<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>

<script>
  
</script>
</body>
</html>

products/templates/products/home.html
{% extends 'products/base.html' %}


{% block content %}

  <div class="container my-5">
  	<h2 class="my-5">Featured Products</h2>
    <div class="row">
      {% for product in object_list %}
		  <div class="col-md-6 col-sm-12 col-lg-3">
			<figure class="card card-product">
				<div class="img-wrap"> 
					<img src="media/{{ product.mainimage }}" style="width: 100%; height: 300px;">
				</div>
				<figcaption class="info-wrap">
					<h6 class="title text-dots"><a href="{{ product.get_absolute_url }}">{{ product.name }}</a></h6>
					
					<div class="action-wrap">
						<!-- <a href="cart/{{ product.slug }}" class="btn btn-primary btn-sm"> Add to Cart </a>
            			<a href="cart/" class="btn btn-primary btn-sm"> View Cart </a> -->
<!--             <a href="remove/{{ product.slug }}" class="btn btn-danger btn-sm"> Remove</a>
 -->						<!-- price-wrap.// -->
						 <div class="price-wrap h5">
							<span class="price-new">${{product.price}}</span>
							<del class="price-old">$1980</del>
						</div> 
					</div> <!-- action-wrap -->
				</figcaption>
			</figure> <!-- card // -->
		</div> <!-- col // -->
      {% endfor %}
  </div>
  </div>
{% endblock %}

products/templates/products/home_previous.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <title>Djago Ecommer | manascode.com</title>
</head>
<body>
  <div class="container">
    <div class="row">
      {% for product in object_list %}
      <div class="col-md-4 col-sm-12 col-lg-3 m-1">
              <div class="card" style='width:100%; height:300px;'>
                <img src="media/{{ product.mainimage }}" style="width:100%;" class="card-img-top" alt="{{ product.name }}">
                      <div class="card-body">
                        <h5 class="card-title"> {{ product.name }}</h5>
                        <p class="card-text">{{ product.preview_text }}</p>
                      </div>
                  <div class='card-footer text-center'>
                  <!--<a href="#" class="btn btn-success">Add to Cart</a>-->
                  <a href="cart/{{ product.slug }}" class="btn btn-success">Add to Cart</a>
                  <a href="remove/{{ product.slug }}" class="btn btn-danger">Remove from Cart</a>
                  </div>
               </div>
        </div>
      {% endfor %}
  </div>
  </div>
</body>
</html>

products/templates/products/navbar.html
{% load cart_tag %}

<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <div class="container">
  <a class="navbar-brand" href="/">Django Ecommerce Project</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbarNav">
    <ul class="navbar-nav ml-auto">
      <li {% if request.path == 'contact' %}class="nav-item active"{% else %}class="nav-item"{% endif %}>
        <a class="nav-link" href="#">Men <span class="sr-only">(current)</span></a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="#">Women</a>
      </li>
      <li class="nav-item">
        <a class="nav-link" href="#">Electronics</a>
      </li>
       <li class="nav-item">
        <a class="nav-link" href="#">Electronics</a>
      </li>
      {% if request.user.is_authenticated %}
      <li class="nav-item">
        <a class="nav-link" href="{% url 'mainapp:cart-home' %}">
          <i class="fa fa-shopping-cart"></i> Cart
          <span class="badge badge-light">{{ request.user| cart_total }}</span>
        </a>
      </li>
       <li class="nav-item">
        
      </li>
      <li class="nav-item dropdown">
        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
          <i class="fas fa-user-tie"></i> {{ request.user.username }}
        </a>
        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
          <a class="dropdown-item" href="#">Dashboard</a>
          <a class="dropdown-item" href="{% url 'checkout:oderView' %}">Orders</a>
          <div class="dropdown-divider"></div>
          <a class="dropdown-item" href="#">Logout</a>
        </div>
      </li>
      {% else %}
       <li class="nav-item">
        <a  class="btn btn-primary" href="/accounts/login/">Login / Register</a>
      </li>
      {% endif %}
    </ul>
  </div>
  </div>
</nav>

products/templates/products/product_detail.html
{% extends 'products/base.html' %}


{% block content %}


<div class="container my-5">

	
<div class="card">
	<div class="row">
		<aside class="col-sm-5 border-right">
<article class="gallery-wrap"> 
<div class="img-big-wrap">
  <div> <a href="#"><img src="/media/{{ object.mainimage }}" style="width: 450px"></a></div>
</div> <!-- slider-product.// -->
</article> <!-- gallery-wrap .end// -->
		</aside>
		<aside class="col-sm-7">
<article class="card-body p-5">
	<h3 class="title mb-3">{{ object.name }}</h3>
<p class="price-detail-wrap"> 
	<span class="price h3 text-warning"> 
		<span class="currency">US $</span><span class="num">{{ object.price }}</span>
	</span> 
	
</p> <!-- price-detail-wrap .// -->
<dl class="item-property">
  <dt>Description</dt>
  <dd><p>{{ object.preview_text }}</p></dd>
</dl>

	<a href="{% url 'mainapp:cart' object.slug %}" class="btn btn-lg btn-outline-primary text-uppercase"> <i class="fas fa-shopping-cart"></i> Add to cart </a>
</article> <!-- card-body.// -->
		</aside> <!-- col.// -->
	</div> <!-- row.// -->
</div> <!-- card.// -->


</div>
<!--container.//-->
{% endblock %}